function res = generateAMatrix(siz,lambda,mu,spacing)

    nodims = length(siz);
    
    acells = cell(nodims,nodims);
    disp(['Generating coefficient matrix with ' int2str(nodims) 'x' int2str(nodims) ' submatrices:']);
    for x1 = 1:nodims
        for x2 = 1:nodims
            disp(['- Generate submatrix ' int2str(x1) ',' int2str(x2)]);
            if x1==x2
                cmd = 'zeros(3,';
                for ctr=2:nodims
                    cmd = [cmd '3,'];
                end
                cmd = [cmd(1:end-1) ');'];
                stamp = eval(cmd);
                for x3=1:nodims
                    if x1==x3
                        stamp = stamp + (lambda+2*mu)*getFinDiffKernel(nodims,x1,x2,spacing);
                    else
                        stamp = stamp + mu*getFinDiffKernel(nodims,x3,x3,spacing);
                    end
                end
            else
                stamp = (lambda+mu)*getFinDiffKernel(nodims,x1,x2,spacing);
            end
            
            acells{x1,x2} = generateAMatrixpart(siz,stamp);
            
        end
    end
    disp('Finished matrix generation.');
    res = cell2mat(acells);

end
