% generates the A matrix for the elastic registration method according to Modersitzki and Fischer
function res = generateAMatrixpart(siz,stamp)

    nodims = length(siz);
    
    idx = find(stamp~=0);
    M = reshape( 1:prod(siz),siz );
    
    % periodic boundary conditions for n-dimensional matrix
    % replace repmat_lighspeed with repmat if you don't have th Lightspeed toolbox available.
    for i=1:nodims
        precolons = repmat(':,',1,i-1);
        postcolons = repmat(':,',1,nodims-i+1);
        if ~isempty(postcolons)
            postcolons = [',' postcolons(1:end-1)];
        end
        cmd = ['cat( ' int2str(i) ', M(' precolons 'end' postcolons '),M,M(' precolons '1' postcolons '));'];
        M = eval(cmd);
    end

    sizM = size(M);
    
    vi = reshape(1:numel(M),size(M)); % indices to visit
    cmd = ['vi(' repmat('2:end-1,',1,nodims)];
    cmd = [cmd(1:end-1) ');'];
    vi = eval(cmd);    
    vi = reshape(vi,numel(vi),1);    

    res = spalloc( numel(vi),numel(vi),7*numel(vi) ); % result matrix res

    % prepare eval commands -----------------------------------------------
    cmdstr1 = '[';
    for i=1:nodims
        cmdstr1 = [cmdstr1 'x' int2str(i) ','];
    end
    cmdstr1 = [cmdstr1(1:end-1) '] = ind2sub(sizM,vi(elemidx));'];

    cmdstr2 = 'M(';
    for i=1:nodims
        cmdstr2 = [cmdstr2 'x' int2str(i) '-1:x' int2str(i) '+1,'];
    end
    cmdstr2 = [cmdstr2(1:end-1) ');'];    
    % =====================================================================
    
    disp(blanks(13));
    for elemidx=1:length(vi)       
%        [x1,x2,x3] = ind2sub(sizM,vi(i)); % get volume indices
        eval(cmdstr1);
        
%        tvol = M(x1-1:x1+1,x2-1:x2+1,x3-1:x3+1); % get subvolume
        tvol = eval(cmdstr2);
        tvol = tvol(idx);

        res( elemidx,tvol(tvol~=0)) = stamp(idx(tvol~=0));
        if mod(elemidx,1000)==0
            dispOpaque('%03.2f%% done.',13,elemidx/length(vi)*100);
        end
    end    
    dispOpaque('',14);
end
