function res = getFinDiffKernel(N,i,j,spacing)    
    
    cmd = 'zeros(3,';
    for ctr=2:N
        cmd = [cmd '3,'];
    end
    cmd = [cmd(1:end-1) ');'];
    kernel = eval(cmd);    
    
    if i==j
        
        coeffs = (1/spacing(i)^2) * [1 -2 1]';
        cmd = 'kernel(:,2,';
        for ctr=2:N-1
            cmd = [cmd '2,'];
        end
        cmd = [cmd(1:end-1) ')'];
        cmd = [cmd ' = ' cmd ' + coeffs(:);'];
        eval(cmd);

        res = ndrotate90(kernel,1,i);
        
    else % i~=j
        
        if i>j
            tempj=j;
            j=i;
            i=tempj;
        end
        
        coeffs = [-1 0 1]';

        cmd = 'kernel(:,2,';
        for ctr=2:N-1
            cmd = [cmd '2,'];
        end
        cmd = [cmd(1:end-1) ')'];
        cmd = [cmd ' = ' cmd ' + coeffs(:);'];
        eval(cmd);
        if i~=1
            kernel2 = ndrotate90(kernel,1,i);
        else
            kernel2 = kernel;
        end
        kernel2 = kernel2/(2*spacing(i));
        if j~=1
            kernel3 = ndrotate90(kernel,1,j);
        else
            kernel3 = kernel;
        end
        kernel3 = kernel3/(2*spacing(j));
        kernel = convn(kernel2,kernel3,'same');
        res = kernel; 
    end

end

% Taken from "MATLAB array manipulation tips and tricks", Peter J. Acklam, 2003.
% Rotates n-dimensional matrix around axis perpendicular to dim1-dim2 surface
function Y = ndrotate90(X,dim1,dim2)

    % Largest dimension number we have to deal with.
    nd = max( [ ndims(X) dim1 dim2 ] );
    % Initialize subscript cell array.
    v = {':'};
    v = v(ones(nd,1));
    
    v{dim2} = size(X,dim2):-1:1;
    Y = X(v{:});
    d = 1:nd;
    d([ dim1 dim2 ]) = [ dim2 dim1 ];
    Y = permute(X, d);    
    
end
